#pragma once

#include <vector>
#include <cstdlib>
#include "base.h"

using namespace std;

class pattern_testcase_adversary : public target_testcase_adversary {
  public:
    pattern_testcase_adversary(vector<int> p): p(p) {}
  protected:
    int target(int P, int B) {
      return B ^ p[P % p.size()];
    }
  private:
    vector<int> p;
};

class pattern_adversary : public adversary {
  public:
    pattern_adversary(vector<vector<int>> p): p(p) {}
    pair<int, int> testcase(int T, int t, int MAX_N) {
      testcaseAdversary = new pattern_testcase_adversary(p[t % p.size()]);
      return {MAX_N, rand() % MAX_N + 1};
    }
  protected:
    vector<vector<int>> p;
};

class pattern_fixed_adversary : public adversary {
  public:
    pattern_fixed_adversary(int X, vector<vector<int>> p): X(X), p(p) {}
    pair<int, int> testcase(int T, int t, int MAX_N) {
      testcaseAdversary = new pattern_testcase_adversary(p[t % p.size()]);
      assert(0 < X and X <= MAX_N);
      return {MAX_N, X};
    }
  protected:
    int X;
    vector<vector<int>> p;
};
