#pragma once

#include <cstdlib>
#include <vector>
#include "base.h"

using namespace std;

class stat_testcase_adversary : public testcase_adversary {
  typedef __int128_t bigint;

  public:
    stat_testcase_adversary() : same(sent.size(), 0) {}

    int write(int G, int P, int B) {
      vector<int> next_state[2] = {next(P, 0), next(P, 1)};

      int r = (val(next_state[1 - B]) > val(next_state[B]) ? 1 - B : B);
      if(g < G) r = B;

      g = (r == B ? g + 1 : 0);
      same = next_state[r];

      return r;
    }

  private:
    static bigint f(bigint x) { return x * x * x; }
    static bigint val(vector<int> v) {
      bigint r = 0;
      for(int x : v) r += f(x);
      return r;
    }

    vector<int> next(int pos, int bit) {
      vector<int> next_same = same;
      for(int i = 0; i < same.size(); ++i)
        next_same[i] += (int)(bit == sent[i][pos]);
      return next_same;
    }

    int g = 2;
    vector<int> same;
};

class stat_adversary : public adversary {
  public:
    pair<int, int> testcase(int T, int t, int MAX_N) {
      testcaseAdversary = new stat_testcase_adversary();
      return {MAX_N, rand() % MAX_N + 1};
    }
};